; 
    include \masm32\include\masm32rt.inc
; 

comment * -----------------------------------------------------
                        Build this  template with
                       "CONSOLE ASSEMBLE AND LINK"
        ----------------------------------------------------- *

    tdata STRUCT
      pbuffer dd ?      ; buffer address
      bufsize dd ?      ; buffer size
    tdata ENDS

    start_fill_thread PROTO :DWORD
    fill_thread  PROTO :DWORD

    .data?
      signal dd ?
      loaded dd ?

    .code

start:
   
; 

    call main
    inkey
    exit

; 

    memcnt equ <1024*1024*100>

main proc

    LOCAL pmem1 :DWORD
    LOCAL pmem2 :DWORD
    LOCAL tdat  :tdata

    mov pmem1, alloc(memcnt)                        ; alocate 2 blocks of memory
    mov pmem2, alloc(memcnt)

  ; ||||||||||||||||||||||||||||||||||||||||||||||||
  ; fill pmem1 while working on pmem2
  ; ||||||||||||||||||||||||||||||||||||||||||||||||

    mov eax, pmem1
    mov DWORD PTR tdat.pbuffer, eax
    mov DWORD PTR tdat.bufsize, memcnt              ; 100 meg buffer

    invoke start_fill_thread,ADDR tdat              ; start new thread

  ; ************************************
  ; do your own processing here on pmem2
  ; ************************************

  spinlock0:
    invoke SleepEx,1,0
    cmp signal, 0                                   ; test if thread is finished yet
    jne spinlock0
    print "Thread finished",13,10

  ; ||||||||||||||||||||||||||||||||||||||||||||||||
  ; fill pmem2 while working on pmem1
  ; ||||||||||||||||||||||||||||||||||||||||||||||||

    mov eax, pmem2
    mov DWORD PTR tdat.pbuffer, eax
    mov DWORD PTR tdat.bufsize, memcnt              ; 100 meg buffer

    invoke start_fill_thread,ADDR tdat              ; start new thread

  ; ************************************
  ; do your own processing here on pmem1
  ; ************************************

  spinlock1:
    invoke SleepEx,1,0
    cmp signal, 0                                   ; test if thread is finished yet
    jne spinlock1
    print "Thread finished",13,10

  ; ||||||||||||||||||||||||||||||||||||||||||||||||

    free pmem2
    free pmem1

    ret

main endp

; 

start_fill_thread proc pstruct:DWORD

    LOCAL tID   :DWORD

    mov loaded, 0                       ; clear the loaded flag

    invoke CreateThread,0,0,fill_thread,pstruct,0,ADDR tID

  spinlock:
    invoke SleepEx,1,0
    cmp loaded, 1
    jne spinlock

    print "Thread started",13,10

    mov eax, tID

    ret

start_fill_thread endp

; 

fill_thread proc pstruct:DWORD

    LOCAL pbuf  :DWORD
    LOCAL sbuf  :DWORD

    push ebx
    push esi
    push edi

    mov signal, 1                       ; set the signal flag
    mov edi, pstruct

    lea ecx, (tdata PTR [edi]).pbuffer  ; copy structure data to LOCAL
    mov ecx, [ecx]
    mov pbuf, ecx

    lea ecx, (tdata PTR [edi]).bufsize  ; copy structure data to LOCAL
    mov ecx, [ecx]
    mov sbuf, ecx

    mov loaded, 1                       ; set the loaded flag for the calling proc

    invoke memfill,pbuf,sbuf,0

    pop edi
    pop esi
    pop ebx

    mov signal, 0                       ; clear the signal flag

    ret

fill_thread endp

; 


end start
